#pragma once

#include "voxel_painter.hpp"
#include "projection.hpp"

namespace BGTU::ComputerGraphicsLabWork::RendererApi {
	class SpriteMetadata {
	public:
		virtual void clicked() {};
	};

	template<class data_t, class voxel_painter_t = VirtualVoxelPainter>
	class Sprite : public SpriteMetadata {
	public:
		virtual void draw(voxel_painter_t *frame, data_t const *data) const = 0;

		class SpriteDataProvider {
		public:
			virtual data_t get_sprite_data() = 0;
		};
	};
}