namespace BGTU::ComputerGraphicsLabWork::Utilities::Shapes {
	template<>
	inline void fill_rectangle_pp<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2>::component_t left,
			RendererApi::PointI<2>::component_t top,
			RendererApi::PointI<2>::component_t right,
			RendererApi::PointI<2>::component_t bottom,
			double z,
			RendererApi::Color::Transparent fill
	) {
		painter->fill_rectangle(left, top, right, bottom, z, fill);
	}

	template<>
	inline void fill_rectangle_pp<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2> tl,
			RendererApi::PointI<2> br,
			double z,
			RendererApi::Color::Transparent fill
	) {
		painter->fill_rectangle(tl.x, tl.y, br.x, br.y, z, fill);
	}

	template<>
	inline void fill_rectangle_ps<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2>::component_t x,
			RendererApi::PointI<2>::component_t y,
			RendererApi::PointI<2>::component_t width,
			RendererApi::PointI<2>::component_t height,
			double z,
			RendererApi::Color::Transparent fill
	) {
		painter->fill_rectangle(x, y, x + width, y + height, z, fill);
	}

	template<>
	inline void fill_rectangle_ps<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2> tl,
			RendererApi::PointI<2>::component_t width,
			RendererApi::PointI<2>::component_t height,
			double z,
			RendererApi::Color::Transparent fill
	) {
		painter->fill_rectangle(tl.x, tl.y, tl.x + width, tl.y + height, z, fill);
	}


	template<>
	inline void fill_rectangle_pp<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2>::component_t left,
			RendererApi::PointI<2>::component_t top,
			RendererApi::PointI<2>::component_t right,
			RendererApi::PointI<2>::component_t bottom,
			double z,
			RendererApi::Color::Transparent fill,
			RendererApi::SpriteMetadata *owner
	) {
		painter->fill_rectangle(left, top, right, bottom, z, fill, owner);
	}

	template<>
	inline void fill_rectangle_pp<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2> tl,
			RendererApi::PointI<2> br,
			double z,
			RendererApi::Color::Transparent fill,
			RendererApi::SpriteMetadata *owner
	) {
		painter->fill_rectangle(tl.x, tl.y, br.x, br.y, z, fill, owner);
	}

	template<>
	inline void fill_rectangle_ps<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2>::component_t x,
			RendererApi::PointI<2>::component_t y,
			RendererApi::PointI<2>::component_t width,
			RendererApi::PointI<2>::component_t height,
			double z,
			RendererApi::Color::Transparent fill,
			RendererApi::SpriteMetadata *owner
	) {
		painter->fill_rectangle(x, y, x + width, y + height, z, fill, owner);
	}

	template<>
	inline void fill_rectangle_ps<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2> tl,
			RendererApi::PointI<2>::component_t width,
			RendererApi::PointI<2>::component_t height,
			double z,
			RendererApi::Color::Transparent fill,
			RendererApi::SpriteMetadata *owner
	) {
		painter->fill_rectangle(tl.x, tl.y, tl.x + width, tl.y + height, z, fill, owner);
	}


	template<>
	inline void fill_square<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2>::component_t x,
			RendererApi::PointI<2>::component_t y,
			RendererApi::PointI<2>::component_t size,
			double z,
			RendererApi::Color::Transparent fill
	) {
		painter->fill_rectangle(x, y, x + size, y + size, z, fill);
	}

	template<>
	inline void fill_square<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2> tl,
			RendererApi::PointI<2>::component_t size,
			double z,
			RendererApi::Color::Transparent fill
	) {
		painter->fill_rectangle(tl.x, tl.y, tl.x + size, tl.y + size, z, fill);
	}

	template<>
	inline void fill_square<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2>::component_t x,
			RendererApi::PointI<2>::component_t y,
			RendererApi::PointI<2>::component_t size,
			double z,
			RendererApi::Color::Transparent fill,
			RendererApi::SpriteMetadata *owner
	) {
		painter->fill_rectangle(x, y, x + size, y + size, z, fill, owner);
	}

	template<>
	inline void fill_square<DefaultVoxelDrawerCache::VoxelPainterImpl>(
			DefaultVoxelDrawerCache::VoxelPainterImpl *painter,
			RendererApi::PointI<2> tl,
			RendererApi::PointI<2>::component_t size,
			double z,
			RendererApi::Color::Transparent fill,
			RendererApi::SpriteMetadata *owner
	) {
		painter->fill_rectangle(tl.x, tl.y, tl.x + size, tl.y + size, z, fill, owner);
	}
}