#pragma once

#include <cstdlib>
#include <utility>
#include <limits>
#include <bgtu/computer_graphics_lab_work/renderer_api/point.hpp>
#include "bgtu/computer_graphics_lab_work/utilities/shapes/line.hpp"

namespace BGTU::ComputerGraphicsLabWork::Utilities {

	template<class receiver_t>
	void fill_triangle(
			RendererApi::PointI<2>::component_t x0, RendererApi::PointI<2>::component_t y0,
			RendererApi::PointI<2>::component_t x1, RendererApi::PointI<2>::component_t y1,
			RendererApi::PointI<2>::component_t x2, RendererApi::PointI<2>::component_t y2,
			receiver_t receiver
	) noexcept(receiver(static_cast<bool>(false), static_cast<RendererApi::PointI<2>::component_t>(0), static_cast<RendererApi::PointI<2>::component_t>(0)));
	class triangle_fill_iterable {
	private:
		brezenham_line_iterable upper_left;
		brezenham_line_iterable lower_left;
		brezenham_line_iterable right;

		template<class receiver_t>
		friend
		void fill_triangle(
				RendererApi::PointI<2>::component_t x0, RendererApi::PointI<2>::component_t y0,
				RendererApi::PointI<2>::component_t x1, RendererApi::PointI<2>::component_t y1,
				RendererApi::PointI<2>::component_t x2, RendererApi::PointI<2>::component_t y2,
				receiver_t
		) noexcept(std::declval<receiver_t>()(static_cast<bool>(false), static_cast<RendererApi::PointI<2>::component_t>(0), static_cast<RendererApi::PointI<2>::component_t>(0)));


		inline triangle_fill_iterable(
				brezenham_line_iterable upper_left,
				brezenham_line_iterable lower_left,
				brezenham_line_iterable right
		) : upper_left{upper_left}, lower_left{lower_left}, right{right} {}

		struct _pre_constructor {
		private:
			inline static void sort_points(RendererApi::PointI<2>::component_t *x0, RendererApi::PointI<2>::component_t *y0, RendererApi::PointI<2>::component_t *x1,RendererApi::PointI<2>::component_t *y1, RendererApi::PointI<2>::component_t *x2, RendererApi::PointI<2>::component_t *y2) {
				auto _swap = [](RendererApi::PointI<2>::component_t *sx0, RendererApi::PointI<2>::component_t *sy0, RendererApi::PointI<2>::component_t *sx1, RendererApi::PointI<2>::component_t *sy1) {
					RendererApi::PointI<2>::component_t tmp;

					tmp = *sx0;
					*sx0 = *sx1;
					*sx1 = tmp;

					tmp = *sy0;
					*sy0 = *sy1;
					*sy1 = tmp;
				};

				if (*y0 < *y1)
					_swap(x0, y0, x1, y1);
				if (*y1 < *y2)
					_swap(x1, y1, x2, y2);
				if (*y0 < *y1)
					_swap(x0, y0, x1, y1);
				if (*y0 == *y1 && *x0 < *x1)
					_swap(x0, y0, x1, y1);
				if (*y1 == *y2 && *x2 < *x1)
					_swap(x1, y1, x2, y2);
			}

		public:

			static inline triangle_fill_iterable create(
					RendererApi::PointI<2>::component_t x0, RendererApi::PointI<2>::component_t y0,
					RendererApi::PointI<2>::component_t x1, RendererApi::PointI<2>::component_t y1,
					RendererApi::PointI<2>::component_t x2, RendererApi::PointI<2>::component_t y2
			) {
				_pre_constructor::sort_points(&x0, &y0, &x1, &y1, &x2, &y2);
				return triangle_fill_iterable{brezenham_line_iterable{x0, y0, x1, y1}, brezenham_line_iterable{x1, y1, x2, y2}, brezenham_line_iterable{x0, y0, x2, y2}};
			}
		};

	public:
		inline triangle_fill_iterable(
				RendererApi::PointI<2>::component_t x0, RendererApi::PointI<2>::component_t y0,
				RendererApi::PointI<2>::component_t x1, RendererApi::PointI<2>::component_t y1,
				RendererApi::PointI<2>::component_t x2, RendererApi::PointI<2>::component_t y2
		) : triangle_fill_iterable{_pre_constructor::create(x0, y0, x1, y1, x2, y2)} {
		}

#if 0
		class iterator {
    private:
        brezenham_line_iterable::iterator upper_left;
        brezenham_line_iterable::iterator lower_left;
        brezenham_line_iterable::iterator right;
        RendererApi::PointI<2>::component_t cx, ex, cy;

        friend class triangle_fill;

        inline iterator(
                brezenham_line_iterable const &upper_left,
                brezenham_line_iterable const &lower_left,
                brezenham_line_iterable const &right
        ) : upper_left{upper_left.begin()}, lower_left{lower_left.begin()}, right{right.begin()}, cx{(*this->upper_left).x}, ex{(*this->right).x}, cy{(*this->upper_left).y} {}


        brezenham_line_iterable::iterator &_left() {
            if (this->upper_left == nullptr)
                return this->lower_left;
            else
                return this->upper_left;
        }

    public:
        inline iterator &operator++() {
            if (this->cx < this->ex) {
                this->cx++;
                return *this;
            }
            if (this->upper_left != nullptr) {
                RendererApi::PointI<2>::component_t sx = (*(this->upper_left)).x;
                while (true) {
                    this->upper_left++;
                    if (this->upper_left == nullptr)
                        goto LOWER;
                    if ((*(this->upper_left)).y < this->cy)
                    {
                        this->cy--;
                        return *this;

                    (*++(this->upper_left)).y >= this->cy
                    if ((*(this->upper_left)).x < sx)
                        return *this;
                }
            } else {
                LOWER:
                RendererApi::PointI<2>::component_t sx = (*(this->upper_left)).x;
            }

            while ((*++(this->right)).y >= this->cy) {
                if ((*(this->right)).x > this->ex)
                    return *this;
            }

            this->cy--;


        }

        inline iterator operator++(int) {
            iterator next = *this;
            ++(*this);
            return next;
        }

        inline point operator*() const {
            if (this->swap_flag)
                return point{this->ret, this->arg};
            else
                return point{this->arg, this->ret};
        }

        inline bool operator==(std::nullptr_t) const {
            return this->arg >= this->end_arg;
        }

        inline bool operator!=(std::nullptr_t) const {
            return this->arg < this->end_arg;
        }
    };
#endif
	};


	template<class receiver_t>
	void fill_triangle(
			RendererApi::PointI<2>::component_t x0, RendererApi::PointI<2>::component_t y0,
			RendererApi::PointI<2>::component_t x1, RendererApi::PointI<2>::component_t y1,
			RendererApi::PointI<2>::component_t x2, RendererApi::PointI<2>::component_t y2,
			receiver_t receiver
	) noexcept(receiver(static_cast<bool>(false), static_cast<RendererApi::PointI<2>::component_t>(0), static_cast<RendererApi::PointI<2>::component_t>(0))) {
		triangle_fill_iterable init{x0, y0, x1, y1, x2, y2};
		auto right = init.right.begin();
		RendererApi::PointI<2>::component_t cy = (*right).y;
		RendererApi::PointI<2>::component_t sx = std::numeric_limits<RendererApi::PointI<2>::component_t>::min();
		RendererApi::PointI<2>::component_t ex = std::numeric_limits<RendererApi::PointI<2>::component_t>::max();

		auto loop = [&](brezenham_line_iterable left) {

			for (auto lp: left) {
				if (lp.y == cy) {
					receiver(true, lp.x, lp.y);
					sx = (lp.x > sx) ? (lp.x) : sx;
					continue;
				}

				for (; (*right).y > lp.y; right++) {
					if ((*right).x > sx)
						receiver(true, (*right).x, (*right).y);
					ex = ((*right).x < ex) ? ((*right).x) : ex;
				}
				for (RendererApi::PointI<2>::component_t x = sx + 1; x < ex; x++)
					receiver(false, x, cy);

				cy--;
				receiver(true, lp.x, lp.y);
			}
		};

		loop(init.upper_left);
		loop(init.lower_left);
		for (; right != nullptr; right++) {
			if ((*right).x > sx)
				receiver(true, (*right).x, (*right).y);
		}
	}
}