#include <bgtu/computer_graphics_lab_work/renderer_api/color.hpp>
#include <bgtu/computer_graphics_lab_work/utilities/shader.hpp>

namespace BGTU::ComputerGraphicsLabWork::Utilities {

	class EmptyShader : public Shader {

	public:
		EmptyShader() = default;

		[[nodiscard]] RendererApi::Color::Transparent get_color(double x, double y) const override {
			return RendererApi::Color::Transparent{0, 0, 0, 0};
		}
	};

	static const EmptyShader empty_shader_instance;

	Shader const *Shader::empty_shader = &empty_shader_instance;
}